stages:
  - lint
  - build
  - test

image: in2code/php-dev:8.1-fpm

lint-composer:
  stage: lint
  script:
    - composer validate --strict
  interruptible: true
  needs: []

lint-php:
  stage: lint
  parallel:
    matrix:
      - PHP:
          - '8.1'
          - '8.2'
          - '8.3'
  image: in2code/php:$PHP-fpm
  script:
    - find . -path ./Build -prune -false -o -type f -name '*.php' -print0 | xargs -0 -n1 -P$(nproc) php -l -n > /dev/null
  interruptible: true
  needs: []

build-composer:
  stage: build
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - /tmp/composer/
  script: composer install
  artifacts:
    paths:
      - Build/
  interruptible: true
  needs: []

test-phpunit:
  stage: test
  variables:
    XDEBUG_MODE: coverage
  script:
    - Build/vendor/bin/phpunit --coverage-text
  only:
    changes:
      - Classes/**/*.php
      - FunctionalTests/**/*.php
      - UnitTests/**/*.php
  artifacts:
    paths:
      - Build/artifacts
    reports:
      coverage_report:
        coverage_format: cobertura
        path: Build/artifacts/coverage/cobertura.xml
  interruptible: true
  needs: [ "build-composer" ]
